######################################################
#
# * Copyright 1999 Peter Apian-Bennewitz, pab-opto
# * ALL RIGHTS RESERVED
# * 
# * THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF PAB-OPTO
# * The copyright notice above does not evidence any  actual  or
# * intended  publication of this source code and material is an
# * unpublished work by Peter Apian-Bennewitz.  This  material
# * contains CONFIDENTIAL INFORMATION that is the property and a
# * trade secret of Peter Apian-Bennewitz. Any use,  duplication
# * or  disclosure  not  specifically  authorized  in writing by
# * Peter Apian-Bennewitz is  strictly  prohibited.  THE  RECEIPT  OR
# * POSSESSION  OF  THIS SOURCE CODE AND/OR INFORMATION DOES NOT
# * CONVEY ANY RIGHTS TO REPRODUCE, DISCLOSE OR  DISTRIBUTE  ITS
# * CONTENTS,  OR  TO MANUFACTURE, USE, OR SELL ANYTHING THAT IT
# * MAY DESCRIBE, IN WHOLE OR IN PART.
#  
######################################################


#######################
#
#	screen dump selector
#	on a per-window specefication
#
#######################


proc dump_sel { ns base } {

    namespace eval ${ns} {

	variable ns [uplevel {concat $ns}]
	variable base [uplevel {concat $base}]
	set pdm $base.dump_sel

	#
	# change suffix if possible
	#
	proc resuff {} {
	  upvar ns ns
	  upvar ${ns}::dump_file dump_file
	  upvar ${ns}::dump_format dump_format
	  set sfilename [ split $dump_file "." ]
	  set last [ expr [ llength $sfilename ] - 1 ]
	  if { [ lsearch -regexp $sfilename {pic|tif} ] == $last } {
		set new [ lreplace $sfilename $last $last $dump_format ]
		set ${ns}::dump_file [ join $new "." ]
	  }

	}

	#
	# auto generate filename
	#
	proc autoname {} {
	}

	if { [ winfo exists $pdm ] } {
		wm deiconify $pdm
		raise $pdm
		return
	} else {
		toplevel $pdm
		set fstyle "-borderwidth 5"
		set ${ns}::dump_format "tif"
		set ${ns}::dump_enlarge 1
	}

	label $pdm.t0 -text "screen dump $base" 

	set ${ns}::dump_format "pic"
	set ${ns}::dump_enlarge 1

	frame $pdm.p 

	label $pdm.p.l1 -text "file"
	label $pdm.p.l2 -text "format"
	label $pdm.p.l3 -text "enlarge"

	#
	# filename frame
	#

	eval frame $pdm.p.fn $fstyle
	entry $pdm.p.fn.file  -textvariable ${ns}::dump_file -width 20
	button $pdm.p.fn.auto  -text "auto name" -command "[ namespace code {autoname}]" -borderwidth 1
	button $pdm.p.fn.lookup  -text "browse" -command "[ namespace code {autoname}]" -borderwidth 1
	grid $pdm.p.fn.file   -columnspan 2
	#grid $pdm.p.fn.auto   -column 0 -row 1
	#grid $pdm.p.fn.lookup -column 1 -row 1
	

	#
	# format frame
	#

	eval frame $pdm.p.format $fstyle
	radiobutton $pdm.p.format.f1 -text "Radiance" \
		-value "pic" -variable ${ns}::dump_format -command "[ namespace code {resuff}]"
	radiobutton $pdm.p.format.f2 -text "Tiff (lzw)" \
		-value "tif" -variable ${ns}::dump_format -command "[ namespace code {resuff}]"
	grid $pdm.p.format.f1
	grid $pdm.p.format.f2

	#
	# enlarge frame
	#

	eval frame $pdm.p.enlarge $fstyle
	radiobutton $pdm.p.enlarge.r1 -text "1" -value 1 -variable ${ns}::dump_enlarge
	radiobutton $pdm.p.enlarge.r2 -text "2" -value 2 -variable ${ns}::dump_enlarge
	radiobutton $pdm.p.enlarge.r3 -text "4" -value 4 -variable ${ns}::dump_enlarge
	grid  $pdm.p.enlarge.r1 -column 0 -row 0
	grid  $pdm.p.enlarge.r2 -column 1 -row 0
	grid  $pdm.p.enlarge.r3 -column 2 -row 0

	grid $pdm.p.l1 -column 0 -row 0 -sticky w
	grid $pdm.p.l2 -column 0 -row 1 -sticky w
	if { $::rshow_squirrel & 1 } {
	  grid $pdm.p.l3 -column 0 -row 2 -sticky w
	}

	grid $pdm.p.fn    -column 1 -row 0 
	grid $pdm.p.format  -column 1 -row 1 -sticky w
	if { $::rshow_squirrel & 1 } {
	  grid $pdm.p.enlarge -column 1 -row 2 -sticky w
	}

	# buttons
	button $pdm.ca  -text "cancel" -command "destroy ${pdm}"
	button $pdm.dump  -text "dump it" \
		 -command "$base.acker guitrig D \$${ns}::dump_file \$${ns}::dump_format \$${ns}::dump_enlarge"

	grid $pdm.t0 -column 0 -row 0 -columnspan 2
	grid $pdm.p -column 0 -row 1 -columnspan 2

	grid $pdm.dump  -column 0 -row 2 
	grid $pdm.ca  -column 1 -row 2 
	
	
    }

}
