######################################################
#
# * Copyright 1999 Peter Apian-Bennewitz, pab-opto
# * ALL RIGHTS RESERVED
# * 
# * THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF PAB-OPTO
# * The copyright notice above does not evidence any  actual  or
# * intended  publication of this source code and material is an
# * unpublished work by Peter Apian-Bennewitz.  This  material
# * contains CONFIDENTIAL INFORMATION that is the property and a
# * trade secret of Peter Apian-Bennewitz. Any use,  duplication
# * or  disclosure  not  specifically  authorized  in writing by
# * Peter Apian-Bennewitz is  strictly  prohibited.  THE  RECEIPT  OR
# * POSSESSION  OF  THIS SOURCE CODE AND/OR INFORMATION DOES NOT
# * CONVEY ANY RIGHTS TO REPRODUCE, DISCLOSE OR  DISTRIBUTE  ITS
# * CONTENTS,  OR  TO MANUFACTURE, USE, OR SELL ANYTHING THAT IT
# * MAY DESCRIBE, IN WHOLE OR IN PART.
#  
######################################################



#############################################################
#
#	add-on tcl code, included from 'gui.tcl'
#
#	$Header: /users/apian/r/rshow/RCS/gui1_add.tcl,v 1.35 2000/02/06 22:43:23 apian Exp $
#
#	define diverse Menues
#

#
#	file menu
#

menu $base.file.m -tearoff 0
     $base.file.m add command -label "view file" -underline 0 -accelerator F1\
		-command "file_sel ${ns}::viewfilesel ./ *.vf {$base.acker guitrig F} "
     $base.file.m add command -label "set window size" -underline 6 -accelerator F11\
		-command "$base.acker guitrig W"
     $base.file.m add command -label "screendump" -underline 6 -accelerator Print \
		-command "dump_sel ${ns} $base"
     $base.file.m add cascade -label "new window" -menu $base.file.m.nw
     $base.file.m add command -label "radiance parameter"  -command rview_radpar
     $base.file.m add command -label "rendering" -underline 6 \
		-command "$base.acker guitrig R"
     $base.file.m add command -label "close" -command "$base.acker guitrig W c"
     $base.file.m add command -label "exit" -underline 0 -command "ourexit"

menu $base.file.m.nw -tearoff 0
	$base.file.m.nw add command -label "managed"   -command "$base.acker guitrig W 1"
	$base.file.m.nw add command -label "unmanaged" -command "$base.acker guitrig W 0"
	$base.file.m.nw add command -label "floor plan" -command "$base.acker guitrig W z"
	

menu $base.view_all.m -tearoff 0
     $base.view_all.m add command -label "to +x" -command "$base.acker guitrig A +x"
     $base.view_all.m add command -label "to +y (default)" -accelerator r \
			 -command "$base.acker guitrig A +y"
     $base.view_all.m add command -label "to -z (top view)" -accelerator R \
			 -command "$base.acker guitrig A -z"
     $base.view_all.m add command -label "to -x" -command "$base.acker guitrig A -x"
     $base.view_all.m add command -label "to -y" -command "$base.acker guitrig A -y"
     $base.view_all.m add command -label "to +z" -command "$base.acker guitrig A +z"


#
#	camera type (perspective|parallel)
#

menu $base.cam_type.m -tearoff 0
	$base.cam_type.m add command -label "perspective" \
		-command "set ${ns}::ctype 1 ; $base.acker guitrig t"
	$base.cam_type.m add command -label "parallel" \
		-command "set ${ns}::ctype 2 ; $base.acker guitrig t"

trace variable ${ns}::ctype w update_type_string

proc update_type_string { v e op } {
	upvar $v vv
	set n [ namespace qualifiers $v ]::ctstring
	upvar $n nn
	switch $vv {
	  1 { set nn "persp" }
	  2 { set nn "paral " }
	}
}



#############################################################
#
#	traps & binds
#

wm protocol $base WM_DELETE_WINDOW {
	ourexit
}

bind $base <Escape> {
	ourexit
}

bind $base <c> {
	%W.acker guitrig W c
}

bind $base.posx_entry <Return> "$base.acker guitrig a "
bind $base.posy_entry <Return> "$base.acker guitrig a "
bind $base.posz_entry <Return> "$base.acker guitrig a "
bind $base.tilt_entry <Return> "$base.acker guitrig a "
bind $base.aspect_entry <Return> "$base.acker guitrig a "
bind $base.fov_entry  <Return> "$base.acker guitrig a "

menu $base.acker.pm
	$base.acker.pm add command -label "bing1" -command " "
	$base.acker.pm add command -label "bing2" -command " "

#
#	mouse event handling
#
	
proc mouse_track {flag org} {
	if {$flag} {
		bind ${org} <Motion> {%W guitrig P %x %y}
	} else {
		bind ${org} <Motion> {}
	}
}

bind $base.acker <ButtonPress-3> {
	%W guitrig P %x %y
	mouse_track 1 %W
}
bind $base.acker <ButtonRelease-3> {
	mouse_track 0 %W
}
bind $base.acker <ButtonPress-2> {
	%W guitrig C %x %y
}

#
#	function keys (backward compatible)
#

bind $base <F1> "file_sel ${ns}::viewfilesel ./ *.vf {$base.acker guitrig F} "
bind $base <F11> "$base.acker guitrig W"
bind $base <Print> "dump_sel ${ns} $base"
bind $base <r> "$base.acker guitrig A +y"
bind $base <R> "$base.acker guitrig A -z"

#
bind $base.left <ButtonPress>   "namespace eval $ns { $base.acker guitrig f 1 -\$velo }"
bind $base.left <ButtonRelease> "namespace eval $ns { $base.acker guitrig f 1 0 }"
bind $base.right <ButtonPress>   "namespace eval $ns { $base.acker guitrig f 1 \$velo }"
bind $base.right <ButtonRelease> "namespace eval $ns { $base.acker guitrig f 1 0 }"
#
bind $base.forw <ButtonPress>   "namespace eval $ns { $base.acker guitrig f 2 -\$velo }"
bind $base.forw <ButtonRelease> "namespace eval $ns { $base.acker guitrig f 2 0 }"
bind $base.back <ButtonPress>   "namespace eval $ns { $base.acker guitrig f 2 \$velo }"
bind $base.back <ButtonRelease> "namespace eval $ns { $base.acker guitrig f 2 0 }"
#
bind $base.down <ButtonPress>   "namespace eval $ns { $base.acker guitrig f 3 -\$velo }"
bind $base.down <ButtonRelease> "namespace eval $ns { $base.acker guitrig f 3 0 }"
bind $base.up <ButtonPress>   "namespace eval $ns { $base.acker guitrig f 3 \$velo }"
bind $base.up <ButtonRelease> "namespace eval $ns { $base.acker guitrig f 3 0 }"

wm title  $base "rshow $::octname $base"

proc ourexit {} {		# add has-saved checking etc.
	exit
}

source "$::rshow_path/file_sel.tcl"
source "$::rshow_path/material-popup.tcl"
source "$::rshow_path/instance_geo.tcl"
source "$::rshow_path/cam_geo.tcl"
source "$::rshow_path/point_geo.tcl"
source "$::rshow_path/coors_geo.tcl"
source "$::rshow_path/radpar.tcl"
source "$::rshow_path/error-popup.tcl"
source "$::rshow_path/fciscale.tcl"
source "$::rshow_path/dump_sel.tcl"

#if { $::rshow_squirrel == "nuts" } {
#	source "$::rshow_path/flexs.tcl
#}

wm iconify .
