######################################################
#
# * Copyright 1999 Peter Apian-Bennewitz, pab-opto
# * ALL RIGHTS RESERVED
# * 
# * THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF PAB-OPTO
# * The copyright notice above does not evidence any  actual  or
# * intended  publication of this source code and material is an
# * unpublished work by Peter Apian-Bennewitz.  This  material
# * contains CONFIDENTIAL INFORMATION that is the property and a
# * trade secret of Peter Apian-Bennewitz. Any use,  duplication
# * or  disclosure  not  specifically  authorized  in writing by
# * Peter Apian-Bennewitz is  strictly  prohibited.  THE  RECEIPT  OR
# * POSSESSION  OF  THIS SOURCE CODE AND/OR INFORMATION DOES NOT
# * CONVEY ANY RIGHTS TO REPRODUCE, DISCLOSE OR  DISTRIBUTE  ITS
# * CONTENTS,  OR  TO MANUFACTURE, USE, OR SELL ANYTHING THAT IT
# * MAY DESCRIBE, IN WHOLE OR IN PART.
#  
######################################################


proc main_ui {root args} {

#	puts "tcl details:"
#	puts $::tcl_patchLevel

	set base ""
    
	label $base.logo_label \
		-background blue \
		-foreground white \
		-bitmap @$::rshow_path/rshow-logo.xbm \
		-borderwidth 10 \
		-cursor coffee_mug \
		-relief sunken \
		-text bla

	label $base.logo_text -text "-READING OCTREE-"

	label $base.version_label \
		-foreground red \
		-text "-"

	menubutton $base.bla -menu $base.bla.m -text bla

	menu $base.bla.m
	$base.bla.m add checkbutton -label hm


	# Geometry management

	grid $base.logo_label -in $root	-row 1 -column 1 
	grid $base.logo_text -in $root	-row 2 -column 1 
	grid $base.version_label -in $root	-row 3 -column 1 
#	grid $base.bla -in $root

	# Resize behavior management

	grid rowconfigure $root 1 -weight 0 -minsize 2
	grid rowconfigure $root 2 -weight 0 -minsize 30
	grid columnconfigure $root 1 -weight 0 -minsize 67

# additional interface code
wm iconbitmap . @$::rshow_path/rshow-logo.xbm
wm title . rshow

# end additional interface code

}


# Allow interface to be run "stand-alone" for testing

catch {
    if [info exists embed_args] {
	# we are running in the plugin
	main_ui .
    } else {
	# we are running in stand-alone mode
	if {$argv0 == [info script]} {
	    wm title . "Testing main_ui"
	    main_ui .
	}
    }
}

