######################################################
#
# * Copyright 1999 Peter Apian-Bennewitz, pab-opto
# * ALL RIGHTS RESERVED
# * 
# * THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF PAB-OPTO
# * The copyright notice above does not evidence any  actual  or
# * intended  publication of this source code and material is an
# * unpublished work by Peter Apian-Bennewitz.  This  material
# * contains CONFIDENTIAL INFORMATION that is the property and a
# * trade secret of Peter Apian-Bennewitz. Any use,  duplication
# * or  disclosure  not  specifically  authorized  in writing by
# * Peter Apian-Bennewitz is  strictly  prohibited.  THE  RECEIPT  OR
# * POSSESSION  OF  THIS SOURCE CODE AND/OR INFORMATION DOES NOT
# * CONVEY ANY RIGHTS TO REPRODUCE, DISCLOSE OR  DISTRIBUTE  ITS
# * CONTENTS,  OR  TO MANUFACTURE, USE, OR SELL ANYTHING THAT IT
# * MAY DESCRIBE, IN WHOLE OR IN PART.
#  
######################################################


#######################
#
#	material popup menu
#
#	$Header: /users/apian/r/rshow/RCS/material-popup.tcl,v 1.22 2000/02/02 19:13:48 apian Exp $
#
#	This window exists only once per rshow.
#
#	called with the message to display
#
#	Offers user a selection of buttons of things to do with
#	selected material
#
#######################

proc mat_popup {wid message picfile} {

	if { [ winfo exists .matdis${wid} ] } {
		.matdis${wid}.mdf.md delete 0.0 end
		.matdis${wid}.mdf.md insert end "$message"
		set ::radpar::imagefile $picfile
		wm deiconify .matdis${wid}
		raise .matdis${wid}
	} else {
		toplevel .matdis${wid}
		set bwidth 14
		set fstyle "-relief raised -borderwidth 3"
		set lstyle "-justify right -anchor e -width 12"
		set bstyle "-justify left -width 14"
		label .matdis${wid}.head -relief flat -text "Radiance object"
		set ::radpar::imagefile $picfile

		#
		# scrollable text display
		#
		frame .matdis${wid}.mdf 
		text .matdis${wid}.mdf.md -height 10 -width 40 -setgrid true -relief sunken \
				-yscrollcommand ".matdis${wid}.mdf.ys set" \
				-xscrollcommand ".matdis${wid}.mdf.xs set" 
		scrollbar .matdis${wid}.mdf.ys -command ".matdis${wid}.mdf.md yview"
		scrollbar .matdis${wid}.mdf.xs -orient horizontal -command ".matdis${wid}.mdf.md xview"

		.matdis${wid}.mdf.md insert end "$message"

		grid .matdis${wid}.mdf.md -in .matdis${wid}.mdf -row 0 -column 0 -sticky nsew
		grid .matdis${wid}.mdf.ys -in .matdis${wid}.mdf -row 0 -column 1 -sticky ns
		grid .matdis${wid}.mdf.xs -in .matdis${wid}.mdf -row 1 -column 0 -sticky ew

		#
		# colorpict
		#
		eval frame .matdis${wid}.cp $fstyle
		button .matdis${wid}.cp.bt -justify left -width $bwidth -text "map colorpict"\
			 -command {::radpar::rad_callback m $::radpar::imagefile} 
		eval label .matdis${wid}.cp.lb1 $lstyle -text {"image file"}
		entry .matdis${wid}.cp.cpi -textvariable ::radpar::imagefile
		grid .matdis${wid}.cp.lb1 -column 0 -row 0 
		grid .matdis${wid}.cp.cpi -column 1 -row 0 
		grid .matdis${wid}.cp.bt  -column 2 -row 0 -sticky e
		

		# rtrace grid
		eval frame .matdis${wid}.rg $fstyle
		button .matdis${wid}.rg.bt -justify left -width $bwidth -text "rtrace grid"\
			 -command {::radpar::rad_callback g\
				 $::radpar::rtracefile $::radpar::rtracestep $::radpar::rtracedist} 
		entry .matdis${wid}.rg.rgi -textvariable ::radpar::rtracefile 
		entry .matdis${wid}.rg.st  -textvariable ::radpar::rtracestep 
		entry .matdis${wid}.rg.dis -textvariable ::radpar::rtracedist
		eval label .matdis${wid}.rg.lb1 $lstyle -text {"outputfile"}
		eval label .matdis${wid}.rg.lb2 $lstyle -text {"step"}
		eval label .matdis${wid}.rg.lb3 $lstyle -text {"dist"}
		grid .matdis${wid}.rg.lb1 -column 0 -row 0 -sticky e
		grid .matdis${wid}.rg.lb2 -column 0 -row 1 -sticky e
		grid .matdis${wid}.rg.lb3 -column 0 -row 2 -sticky e
		grid .matdis${wid}.rg.rgi -column 1 -row 0 
		grid .matdis${wid}.rg.st  -column 1 -row 1 
		grid .matdis${wid}.rg.dis -column 1 -row 2 
		grid .matdis${wid}.rg.bt  -column 2 -row 0 -rowspan 3 -sticky e
		

		# illuminance calc
		eval frame .matdis${wid}.ic $fstyle
		button .matdis${wid}.ic.bt -justify left -width $bwidth -text "illuminance"\
			 -command {::radpar::rad_callback i\
				$::radpar::rtracestep\
				$::radpar::rtracedist\
				$::radpar::rtracemax}
		entry .matdis${wid}.ic.st  -textvariable ::radpar::rtracestep 
		entry .matdis${wid}.ic.dis -textvariable ::radpar::rtracedist
		entry .matdis${wid}.ic.max -textvariable ::radpar::rtracemax
		eval label .matdis${wid}.ic.lb2 $lstyle -text {"step"} 
		eval label .matdis${wid}.ic.lb3 $lstyle -text {"dist"} 
		eval label .matdis${wid}.ic.lb4 $lstyle -text {"max"} 
		grid .matdis${wid}.ic.lb2 -column 0 -row 1 -sticky e
		grid .matdis${wid}.ic.lb3 -column 0 -row 2 -sticky e
		grid .matdis${wid}.ic.lb4 -column 0 -row 3 -sticky e
		grid .matdis${wid}.ic.st  -column 1 -row 1 
		grid .matdis${wid}.ic.dis -column 1 -row 2 
		grid .matdis${wid}.ic.max -column 1 -row 3 
		grid .matdis${wid}.ic.bt  -column 2 -row 1 -rowspan 4 -sticky e
		

		# BRTF visualization

		eval frame .matdis${wid}.brtf $fstyle
		button .matdis${wid}.brtf.bt -justify left -width $bwidth -text "BRTF vis"\
			 -command {::radpar::rad_callback b\
				 $::radpar::brtffile \
				 $::radpar::brtfmax \
				 $::radpar::brtfsize }
		entry .matdis${wid}.brtf.dis -textvariable ::radpar::brtffile
		entry .matdis${wid}.brtf.max -textvariable ::radpar::brtfmax
		entry .matdis${wid}.brtf.size -textvariable ::radpar::brtfsize
		eval label .matdis${wid}.brtf.lb2 $lstyle -text {"brtf file"} 
		eval label .matdis${wid}.brtf.lb3 $lstyle -text {"max"} 
		eval label .matdis${wid}.brtf.lb4 $lstyle -text {"size"} 
		grid .matdis${wid}.brtf.lb2 -column 0 -row 1 -sticky e
		grid .matdis${wid}.brtf.lb3 -column 0 -row 2 -sticky e
		grid .matdis${wid}.brtf.lb4 -column 0 -row 3 -sticky e
		grid .matdis${wid}.brtf.dis -column 1 -row 1 
		grid .matdis${wid}.brtf.max -column 1 -row 2 
		grid .matdis${wid}.brtf.size -column 1 -row 3 
		grid .matdis${wid}.brtf.bt  -column 2 -row 1 -rowspan 3 -sticky e
		

		# cancel
		button .matdis${wid}.ca -text "cancel" -command "destroy .matdis${wid}"

		grid .matdis${wid}.head -columnspan 2
		grid .matdis${wid}.mdf -padx 10 -pady 10 -columnspan 2 -sticky nsew

		grid .matdis${wid}.cp -sticky we

		grid .matdis${wid}.rg -sticky we

		grid .matdis${wid}.ic -sticky we

		if { $::rshow_squirrel & 2 } {
		  grid .matdis${wid}.brtf -sticky we
		}

		grid .matdis${wid}.ca -columnspan 2 

		grid columnconfigure .matdis${wid} 0 -weight 1
		grid rowconfigure .matdis${wid} 1 -weight 1
	}
}

namespace eval ::radpar {
	set rtracefile "rtrace.in"
	set rtracestep 0.5
	set imagefile ""
	set rtracedist 0.01
	set rtracemax 5.0
	set brtffile "brtf"
	set brtfmax 1
	set brtfsize 1
}

