######################################################
#
# * Copyright 1999 Peter Apian-Bennewitz, pab-opto
# * ALL RIGHTS RESERVED
# * 
# * THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF PAB-OPTO
# * The copyright notice above does not evidence any  actual  or
# * intended  publication of this source code and material is an
# * unpublished work by Peter Apian-Bennewitz.  This  material
# * contains CONFIDENTIAL INFORMATION that is the property and a
# * trade secret of Peter Apian-Bennewitz. Any use,  duplication
# * or  disclosure  not  specifically  authorized  in writing by
# * Peter Apian-Bennewitz is  strictly  prohibited.  THE  RECEIPT  OR
# * POSSESSION  OF  THIS SOURCE CODE AND/OR INFORMATION DOES NOT
# * CONVEY ANY RIGHTS TO REPRODUCE, DISCLOSE OR  DISTRIBUTE  ITS
# * CONTENTS,  OR  TO MANUFACTURE, USE, OR SELL ANYTHING THAT IT
# * MAY DESCRIBE, IN WHOLE OR IN PART.
#  
######################################################


#######################
#
#	point_geo pulldown menu
#
#	$Header: /users/apian/r/rshow/RCS/point_geo.tcl,v 1.10 1999/12/18 20:52:30 apian Exp $
#	sourced from gui1_add.tcl,
#	called from point_geo_tcl.c after that function defined
#	namespace and variables for communication
#
#######################

proc point_geo_setup { ns base } {

    namespace eval ${ns} {

	variable ns [uplevel {concat $ns}]
	variable base [uplevel {concat $base}]
	set pdm $base.frame_topbar.pn

	menubutton $pdm -text "grid points" -menu $pdm.m
	grid  $pdm -in ${base}.frame_topbar -row 1 -column 4

	menu $pdm.m 
	$pdm.m add checkbutton -label "display" -onvalue 0x01 \
		-variable ${ns}::style -command "$base.acker guitrig X"
	$pdm.m add command -label "free float" -command "::point_geo::poi_callback f"
	$pdm.m add command -label "read file" -command point_geo_readfile
	$pdm.m add command -label "clear all" -command "::point_geo::poi_callback c"
   }

}

#######################
#
#	rtrace file reading tcl popup
#	once per rshow
#
#######################

proc point_geo_readfile { } {
	set base ".readrtracefile"
	set ns "point_geo"

        if { [ winfo exists ${base} ] } {
	  wm deiconify ${base}
	  raise ${base}
	  return
        }
        toplevel ${base}
        label $base.tit  -text {point file read}
        label $base.file -text "file"
	entry $base.fname -width 20 -textvariable ::${ns}::poi_file
        label $base.scaletext -text "min/max"
	frame $base.scale
	entry $base.scale.min -width 6 -textvariable ::${ns}::scalemin
	entry $base.scale.max -width 6 -textvariable ::${ns}::scalemax
	label $base.help -text "file format is 6 values per line: x y z r g b"
        button $base.ca   -text "cancel" -command "destroy ${base}"
        button $base.read -text "read" -command {::point_geo::poi_callback r $::point_geo::poi_file}

        grid $base.tit   -column 0 -row 0 -columnspan 2
        grid $base.file  -column 0 -row 1 
        grid $base.fname -column 1 -row 1 -sticky w
	grid $base.scaletext -column 0 -row 2
	grid $base.scale.min -column 1 -row 1 -sticky w
	grid $base.scale.max -column 2 -row 1 -sticky w
	grid $base.scale -column 1 -row 2 -sticky w
	grid $base.help	 -column 0 -row 3 -columnspan 2
        grid $base.ca    -column 0 -row 4
        grid $base.read  -column 1 -row 4

	bind $base.scale.min <Return> "::point_geo::poi_callback s"
	bind $base.scale.max <Return> "::point_geo::poi_callback s"
	bind $base.fname     <Return> {::point_geo::poi_callback r $::point_geo::poi_file}
	
}

#namespace eval ::point_geo {}
#point_geo_readfile

