######################################################
#
# * Copyright 1999 Peter Apian-Bennewitz, pab-opto
# * ALL RIGHTS RESERVED
# * 
# * THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF PAB-OPTO
# * The copyright notice above does not evidence any  actual  or
# * intended  publication of this source code and material is an
# * unpublished work by Peter Apian-Bennewitz.  This  material
# * contains CONFIDENTIAL INFORMATION that is the property and a
# * trade secret of Peter Apian-Bennewitz. Any use,  duplication
# * or  disclosure  not  specifically  authorized  in writing by
# * Peter Apian-Bennewitz is  strictly  prohibited.  THE  RECEIPT  OR
# * POSSESSION  OF  THIS SOURCE CODE AND/OR INFORMATION DOES NOT
# * CONVEY ANY RIGHTS TO REPRODUCE, DISCLOSE OR  DISTRIBUTE  ITS
# * CONTENTS,  OR  TO MANUFACTURE, USE, OR SELL ANYTHING THAT IT
# * MAY DESCRIBE, IN WHOLE OR IN PART.
#  
######################################################


#######################
#
#	rview_render pulldown menu
#
#	$Header: /users/apian/r/rshow/RCS/radpar.tcl,v 1.9 2000/01/02 13:50:12 apian Exp $
#	sourced from ...
#	called from ...
#
#	note that this sets parameters for _all_ rshow windows,
#	since the underlying Radiance routines have _one_ set of parameters
#	To avoid confusion, we put them all in one tcl namespace.
#
#######################

proc rview_radpar { } {

	set base ".radpar"
	set ns "radpar"

	if { [ winfo exists ${base} ] } { return }

	toplevel ${base}

	# the following array associates clear text to Radiance internal names
	# and to commandline parameters

	set rte(exposure) "exposure";
	set rts(exposure) "-e";
	set rte(maxdepth) "limit reflexions";
	set rts(maxdepth) "-lr";
	set rte(ambssamp) "ambient supersamples";
	set rts(ambssamp) "-as";
	set rte(ambdiv)   "ambient divisions";
	set rts(ambdiv)   "-ad";
	set rte(ambounce) "ambient bounces";
	set rts(ambounce) "-ab";
	set rte(ambval_double) "ambient constant";
	set rts(ambval_double) "-av";
	set rte(ambacc) "ambient accuracy";
	set rts(ambacc) "-aa";
	set rte(ambres) "ambient resolution";
	set rts(ambres) "-ar";
	set rte(srcsizerat) "direct sampling";
	set rts(srcsizerat) "-ds";
	set rte(dstrsrc) "direct jitter";
	set rts(dstrsrc) "-dj";

	# sort by rts

	proc sorty { a b } {
	  upvar rts($a) bla_a 
	  upvar rts($b) bla_b 
	  return [string compare $bla_a $bla_b]
	}

	
	label $base.header -text "Radiance rendering parameter"
	grid $base.header -row 1 -column 1 -columnspan 3

	set count 2
	foreach v [lsort -command sorty [array names rts] ] {
		eval label $base.e_$v -text {$rte($v)} -justify right 
		eval label $base.s_$v -text {$rts($v)} -justify left 
		eval entry $base.${v}e -textvariable ::${ns}::$v 
		eval grid $base.e_$v -row $count -column 1 -sticky e
		eval grid $base.s_$v -row $count -column 2 -sticky w
		eval grid $base.${v}e -row $count -column 3
		bind  $base.${v}e <Return> "::${ns}::rad_callback p"

		set count [expr $count + 1 ]
	}
	button $base.cancel -text "cancel" -command "destroy ${base}"
	grid $base.cancel -row $count -column 1 
	button $base.apply -text "apply" -command "::${ns}::rad_callback p"
	grid $base.apply -row $count -column 3

}


